;;*    next_word / previous_word macro for CLARION Language
;;*    
;;*    
;;*		.cla_next_word , .cla_previous_word
;;*		
;;*		
;;*
;;*		These definitions are used as "language sensitive" word patterns
;;*	  for CLARION language. The following characters are skipped over:
;;*    space,tab ()[]{},.;:%?~\"'+-=*/|!&<>#
;;*
;;*    Revision History
;;*    ================
;;*    6-June-1989         Kevin Baradet      Incept Date
;;*    
;;*    Installation
;;*    ============
;;*    1) Copy the include directive below into SEARCH.M . 
;;*    Make sure it's in column 1. 
;;*       #include "clasrch.inc"
;;*    2) Recompile SEARCH.M




(macro .cla_next_word
	(
		(int	ret_val)

		(save_position)

		(if (! (index " \t()[]{},.;:%?~\"'+-=*/|!&<>#" (read 1)))
			(next_char)
		)
		(= ret_val (search_fwd "<|[ \t()\\[\\]{},.;:\\%\\?\\~\"'+\\-*\\\\/=|!&><#][~ \t()\\[\\]{},.;:\\%\\?\\~\"'+\\-*\\\\/=|!&><#\n]"))

		(if (index " \t()[]{},.;:%?~\"'+-=*/|!&<>#" (read 1))
			(next_char)
		)
		(restore_position (! ret_val))
		(returns ret_val)
	)
)

(macro .cla_previous_word
	(                               
		(int	ret_val
		        col
                )

		(save_position)
		(inq_position NULL col)
                (prev_char)

		(if ( (|| (> col 2) (index " \t()[]{},.;:%?~\"'+-=*/\\|!&<>#" (read 1))))
			(prev_char)
		)
		(= ret_val (search_back "<|[ \t()\\[\\]{},.;:\\%\\?\\~\"'+\\-*\\\\/=|!&><#][~ \t()\\[\\]{},.;:\\%\\?\\~\"'+\\-*\\\\/=|!&><#\n]" 2))

		(if (index " \t()[]{},.;:%?~\"'+-=*/|!&<>#" (read 1))
			(next_char)
		)
		(restore_position (! ret_val))
		(returns ret_val)
	)
)

