GETDATE    FUNCTION(OPTION,DATEIN)
!---------------------------------------------------------------------!
!  THIS FUNCTION WILL RETURN A STRING CONTAINING THE DATE FORMATED    !
!  EX. (MONDAY AUGUST 15,1988).                                       !
!                                                                     !
!  TO CALL THIS FUNCTION.                                             !
!                                                                     !
!     STRING = GETDATE(OPTION,DATEIN)                                 !
!                                                                     !
!  WHERE:                                                             !
!                                                                     !
!        OPTION = A BYTE FIELD AS FOLLOWS.                            !
!                                                                     !
!                 0 - SHORT FORM OF DAY (MON AUG 15,1988).            !
!                 1 - LONG FORM OF DAY (MONDAY AUGUST 15,1988).       !
!                                                                     !
!        DATEIN = A LONG FIELD CONTAINING THE DATE IN THE FORM        !
!                 RETURNED BY THE CLARION TODAY() FUNCTION.           !
!---------------------------------------------------------------------!
!     COMPILER: CLARION V2.0                                          !
!       SYSTEM: N/A                                                   !
!     FUNCTION: GETDATE                                               !
!  ENVIRONMENT: CALLED HAS A FUNCTION                                 !
!   REFERENCES: NONE                                                  !
!---------------------------------------------------------------------!
!  HISTORY:                                                           !
!    WRITTEN   10/20/88 BY DOMINICK G. GALLUCCI                       !
!    MODIFIED  00/00/00                                               !
!---------------------------------------------------------------------!

DATEIN     LONG                     !DATE
DATEOUT    STRING(30)               !DISPLAY DATE
                                    !17 ABR DATE
                                    !27 LONG DATE
OPTION     BYTE                     !OPTION CODE
                                    !0 SHORT
                                    !1 LONG

  CODE

    IF OPTION = 0 THEN
      DATEOUT= CLIP(DAYOFWK(0,DATEIN)) & ' ' & |
               FORMAT(DATEIN,@D3)
    ELSE
      DATEOUT= CLIP(DAYOFWK(1,DATEIN)) & ' ' & |
               FORMAT(DATEIN,@D4)
    .
    RETURN(CLIP(DATEOUT))
