JULDATE    FUNCTION(DATEIN)
!---------------------------------------------------------------------!
!  THIS FUNCTION WILL RETURN A LONG CONTAINING THE JULIAN DATE OF     !
!  THE DATE PASSED TO IT.                                             !
!                                                                     !
!  TO CALL THIS FUNCTION.                                             !
!                                                                     !
!     LONG = JULDATE(DATEIN)                                          !
!                                                                     !
!  WHERE:                                                             !
!                                                                     !
!        DATEIN = A LONG FIELD CONTAINING THE DATE IN THE FORM        !
!                 RETURNED BY THE CLARION TODAY() FUNCTION.           !
!---------------------------------------------------------------------!
!     COMPILER: CLARION V2.0                                          !
!       SYSTEM: N/A                                                   !
!     FUNCTION: JULDATE                                               !
!  ENVIRONMENT: CALLED HAS A FUNCTION                                 !
!   REFERENCES: NONE                                                  !
!---------------------------------------------------------------------!
!  HISTORY:                                                           !
!    WRITTEN   10/20/88 BY DOMINICK G. GALLUCCI                       !
!    MODIFIED  00/00/00                                               !
!---------------------------------------------------------------------!

DATEIN     LONG                     !DATE
INMTH      LONG                     !MONTH
INDAY      LONG                     !DAY
INYY       LONG                     !YEAR

!---------------------------------------------------------------------!
!        DAY TABLES                                                   !
!---------------------------------------------------------------------!
NOMYERTB GROUP
         SHORT(0)                 !JAN
         SHORT(31)                !FEB
         SHORT(59)                !MAR
         SHORT(90)                !APR
         SHORT(120)               !MAY
         SHORT(151)               !JUN
         SHORT(181)               !JUL
         SHORT(212)               !AUG
         SHORT(243)               !SEP
         SHORT(273)               !OCT
         SHORT(304)               !NOV
         SHORT(334)               !DEC
         .
NOMYEAR  SHORT,DIM(12),OVER(NOMYERTB)
LEYERTB  GROUP
         SHORT(0)                 !JAN
         SHORT(31)                !FEB
         SHORT(60)                !MAR
         SHORT(91)                !APR
         SHORT(121)               !MAY
         SHORT(152)               !JUN
         SHORT(182)               !JUL
         SHORT(213)               !AUG
         SHORT(244)               !SEP
         SHORT(274)               !OCT
         SHORT(305)               !NOV
         SHORT(335)               !DEC
         .
LEYEAR   SHORT,DIM(12),OVER(LEYERTB)

!---------------------------------------------------------------------!
!        FORMAT MMDDYY INTO YYDDD                                     !
!---------------------------------------------------------------------!
  CODE

    INMTH = MONTH(DATEIN)         !SAVE MONTH
    INDAY = DAY(DATEIN)           !SAVE DAY
    INYY  = YEAR(DATEIN) % 4      !FIND TYPE OF YEAR
    IF INYY = 0 THEN
      INDAY += LEYEAR[INMTH]
    ELSE
      INDAY += NOMYEAR[INMTH]
    .                             !END IF
    INDAY += SUB(FORMAT(DATEIN,@D11),1,2) * 1000
    RETURN(INDAY)
