	PAGE 55,120
;-------------------------------------------------------------------------
;		Copyright 1989, SHAND, LTD.
;
;		 Rebecca Lane
;		 Pleasantville, New York 10570
;		 TEL: (914) 747 1272
;		 FAX and Modem: (914) 747 1796
;		 Clarion BBS: ARNS NEUMAN
;		 COMPUSERV: 71250,2421	
;
;
;	MODULE: KBEMPTY.ASM 
;		Clear keyboard buffer and return number of keys cleared.
;-------------------------------------------------------------------------

;----------SYNTAX and CAVEATS---------------------------------------------
;
;	variable = KBEMPTY()	returns a LONG equal 0 if no data erased
;				returns number of keystrokes cleared from 
;				buffer if there was data.
;------------------------------------------------------------------------
;	CLARION MAP
;	
;	MODULE('kbempty'),BINARY
;	  FUNC(kbempty), LONG
;	.
;-----------------------------------------------------------------------
_TEXT	SEGMENT BYTE PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT WORD PUBLIC 'DATA'
_DATA	ENDS
_BSS	SEGMENT WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP _TEXT,_DATA,_BSS

_TEXT	SEGMENT BYTE PUBLIC 'CODE'	;code and data in same segment
	ASSUME CS:_TEXT,DS:DGROUP

;---------- BINARY MODULE HEADER
	DB	'BIO'		;Bin signature for version 2.0
	PUBLIC  LIBVEC		;Public vector to header
LIBVEC	DD	0		;double word reserved
	DW	BINEND		;Length of binary module
	DB	1		;one function in this LEM module

; All functions and procedures must be defined, including parameter
; definitions, at the start of the module.

;----------FUNCTION DEFINITION
	DB	'KBEMPTY',6 DUP(0) ;Clarion function name padded to 13 bytes
				;       with last byte 0
	DW	KBEMPTY		;offset within lem module
	DB	1		;0=procedure, 1= function
	DB	0		;no calling parameters

;----------Parameter definitions (1 required for each calling parameter)
; A parameter definition looks like this
;	DB	x		;where x is 0=string
;                                           1=word
;				 	    2=double word
;            			 	    4=double precision float
;param1  DD	0		 place holder for address of the parameter
;param1l DW	0		 length of parameter
;
;Note that this is really an array with 3 elements for each parameter.
;  (1) A byte which defines the data type.
;  (2) A 4 byte address which is long enough because of segmentation.
;  (3) A 2 byte length. This is longer than necessary. 	
;
;----------KBEMPTY

RETVAL		DD	0		;set up an address for return value
					;note that it is defined as 4 bytes
					;because it must be a Clarion LONG

		PUBLIC	KBEMPTY		;Called as external from Clarion
KBEMPTY	  	PROC	FAR		;This is the function, KBEMPTY 
		SUB	DX,DX		;set DX to 0. This
         				;initializes return value.
		MOV	AH,1		;BIOS function number
		INT	16H		;call BIOS
		
DOITAGAIN:	JZ	SHORT	QUIT	;no data so leave
		INC	DX		;data available so increment count
		MOV	AH,0		;BIOS read keyboard function
		INT	16H		;call BIOS
		MOV	AH,1		;Repeat to test for more data
		INT	16H		;call BIOS
		JMP	SHORT	DOITAGAIN
	
QUIT:
;---------- Prepare to exit to clarion
	MOV	WORD PTR RETVAL, DX
	MOV	AL,2		;set al to 0=string
				;	 1=signed word	
				;	 2=signed double word
				;	 4=double precision float (8087 format)
	MOV	BX,OFFSET RETVAL;address of return value
	RET			;Return to Clarion
KBEMPTY	ENDP			;End of Procedure
BINEND	DB	0		;Marks end of LEM for header purposes
_TEXT	ENDS			;End _TEXT segment
	END			;End the assembly