;-------------------------------------------------------------------
;Copyright 1989, SHAND, LTD.
;		 Rebecca Lane
;		 Pleasantville, New York 10570
;		 TEL: (914) 747 1272
;		 FAX and Modem: (914) 747 1796
;		 Clarion BBS: ARNS NEUMAN
;		 COMPUSERV: 71250,2421	
;
;	MODULE: PASSWORD.ASM
;		Enter a password of up to 40 chars without echo
;-------------------------------------------------------------------

;----------SYNTAX and CAVEATS---------------------------------------
;
;	str_var = password()
;
;	No parameters are required. Return value is a string(LEN(password)).
;	Edit with backspace key only is permitted. Characters allowed are
;	in the range 20H(space) to 7EH(tilde).
;--------------------------------------------------------------------
;	CLARION MAP
;	
;	MODULE('password'), BINARY
;	  FUNC(password),STRING
;	.
;-------------------------------------------------------------------

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT WORD PUBLIC 'DATA'
_DATA	ENDS
_BSS	SEGMENT WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP _TEXT,_DATA,_BSS

_TEXT	SEGMENT BYTE PUBLIC 'CODE'	;code and data in same segment
	ASSUME CS:_TEXT,DS:DGROUP

;---------- BINARY MODULE HEADER
		DB	'BIO'		    ;Bin signature for version 2.0
		PUBLIC  LIBVEC		    ;Public vector to header
	LIBVEC	DD	0		    ;double word reserved
		DW	BINEND		    ;Length of binary module
		DB	1		    ;one function in this LEM module
;----------FUNCTION DEFINITION
		DB	'PASSWORD',5 DUP(0) ;Clarion function name padded
					    ;  to 13 bytes with last byte 0
		DW	PASSWORD	    ;OFFSET WITHIN BINARY MODULE
		DB	1		    ;0=procedure, 1= function
		DB	0		    ;0 calling parameters

	RETVAL	DB	41 DUP(0)	    ;Password buffer initialized

	PUBLIC	PASSWORD		    ;Public procedure 
PASSWORD 	PROC	FAR		    ;assembler will issue a far return
		MOV	CX, 40		    ;set up loop counter
		XOR	BX, BX		    ;initialize index into buffer
GET_ANOTHER:	
		MOV	AH, 07H		    ;read keyboard w/o echo function
					    ;CTRL-BREAK disabled
					    ;use 08H to enable CTRL-BREAK
		INT	21H		    ;call DOS
		CMP	AL, 0DH		    ;carriage return?
		JE	QUIT		    ;if yes we're done
		CMP	AL, 08H		    ;is it backspace?
	        JNE	IS_BELOW	    ;no? get next character
		CMP	BX, 0		    ;  yes? is this first character?
		JE	GET_ANOTHER	    ;    yes? get another character
		DEC	BX		    ;	 no? backspace a character.
		INC	CX		    ;    correct for last loop
		JMP	GET_ANOTHER	    ;get another character
IS_BELOW:	
		CMP	AL, 20H		    ;is it lower than space char
		JAE	IS_ABOVE	    ;no? se if its too high
		CALL	BEEP		    ;yes? sound speaker
	        JMP	GET_ANOTHER	    ;throw away char and get another
IS_ABOVE:	
		CMP	AL, 7EH		    ;is it higher than ~
		JBE	ADD_CHAR	    ;no? add the char
		CALL	BEEP		    ;yes? sound speaker
	   	JMP	GET_ANOTHER	    ;throw away char and get another
ADD_CHAR:
		MOV	RETVAL[BX],AL	    ;add character to string
		INC	BX		    ;point to next position
		LOOP	GET_ANOTHER	    ;get next character
	
QUIT:		
		MOV	RETVAL[BX],'$'      ;terminate the string
  		MOV	AL, 0		    ;returning a string
		MOV	CX, BX              ;length of string
		MOV	BX,OFFSET RETVAL    ;at this address
		RET			    ;Return to Clarion. 

PASSWORD	ENDP			    ;end of procedure

BEEP		PROC	NEAR		    ;sound the speaker
		MOV	DX, 50
		IN	AL, 61H
		AND	AL, 11111110B
NEXT_CYCLE:	
		OR	AL, 00000010B
		OUT	61H, AL
		MOV	CX, 300
FIRST_HALF:	
		LOOP	FIRST_HALF
		AND	AL, 11111101B
		OUT	61H, AL
		MOV	CX, 300
SECOND_HALF:	
		LOOP 	SECOND_HALF
		DEC	DX
		JNZ	NEXT_CYCLE
		RET
BEEP		ENDP
			
	
BINEND		DB	0		    ;mark end of LEM
_TEXT		ENDS			    ;end code segment
		END			    ;end assembly 