SORTFILE PROCEDURE(SORTIN,SORTOUT,SORTPARM,SORTPASS)
!---------------------------------------------------------------------!
!  THIS PROCEDURE WILL SORT A CLARION FILE AND CHECK FOR ERRORS,      !
!  IF A ERROR IS FOUND A MESSAGE IS SENT TO THE SCREEN.		      !
!								      !
!  TO CALL THIS PROCEDURE.					      !
!								      !
!     SORTFILE(SORTIN,SORTOUT,SORTPARM,SORTPASS)		      !
!								      !
!  WHERE:							      !
!								      !
!	 SORTIN	  = THE NAME OF THE CLARION FILE.		      !
!	 SORTOUT  = THE NAME OF THE CLARION FILE.		      !
!	 SORTPARM = SORT PARM SEE CLARION MANUAL.		      !
!	 SORTPASS = PASSWORD SEE CLARION MANUAL.		      !
!---------------------------------------------------------------------!
!     COMPILER: CLARION V2.0					      !
!	SYSTEM: N/A						      !
!    PROCEDURE: SORTFILE					      !
!  ENVIRONMENT: CALLED HAS A PROCEDURE				      !
!   REFERENCES: CLARION FILE AND CSORT				      !
!---------------------------------------------------------------------!
!  HISTORY:							      !
!    WRITTEN   10/20/88 BY DOMINICK G. GALLUCCI			      !
!    MODIFIED  00/00/00						      !
!---------------------------------------------------------------------!

SORTING_MSG  SCREEN	  HUE(7,0,0)
	       ROW(8,24)  STRING('*{5} Please Wait *{5}'),ENH,BLK
	       ROW(6,6)	  STRING('Sorting File:')
		 COL(19)  ENTRY(@S30),USE(SORTIN)
	     .

SORTIN	     EXTERNAL
SORTOUT	     EXTERNAL
SORTPARM     EXTERNAL
SORTPASS     EXTERNAL

  CODE

    ALERT			  !CLEAR ALL ALERT KEY'S
    OPEN(SORTING_MSG)
    DISPLAY			  !DISPLAY FILE NAME
    IF OMITTED(4) THEN
      RUN('CSRT I=' & CLIP(SORTIN) & ' O=' &  |
	CLIP(SORTOUT) & ' K=' & CLIP(SORTPARM) & ' /V')
    ELSE
      RUN('CSRT I=' & CLIP(SORTIN) & ' O=' &  |
	CLIP(SORTOUT) & ' K=' & CLIP(SORTPARM) & ' P=' & CLIP(SORTPASS) & ' /V')
    .				  !END IF
    IF RUNCODE() THEN
      STOP('SORTERR-' & CLIP(SORTIN) & ' RC=' & RUNCODE())
    .
    RETURN
