WEEKOFYR   FUNCTION(DATEIN)
!---------------------------------------------------------------------!
!  THIS FUNCTION WILL RETURN A LONG CONTAINING THE WEEK NUMBER OF     !
!  THE YEAR.                                                          !
!                                                                     !
!  TO CALL THIS FUNCTION.                                             !
!                                                                     !
!     LONG = WEEKOFYR(DATEIN)                                         !
!                                                                     !
!  WHERE:                                                             !
!                                                                     !
!        DATEIN = A LONG FIELD CONTAINING THE DATE IN THE FORM        !
!                 RETURNED BY THE CLARION TODAY() FUNCTION.           !
!---------------------------------------------------------------------!
!     COMPILER: CLARION V2.0                                          !
!       SYSTEM: N/A                                                   !
!     FUNCTION: WEEKOFYR                                              !
!  ENVIRONMENT: CALLED HAS A FUNCTION                                 !
!   REFERENCES: NONE                                                  !
!---------------------------------------------------------------------!
!  HISTORY:                                                           !
!    WRITTEN   10/20/88 BY DOMINICK G. GALLUCCI                       !
!    MODIFIED  00/00/00                                               !
!---------------------------------------------------------------------!

DATEIN     LONG                     !DATE

  CODE

    YEAROFDAY# = YEAR(DATEIN)
    FIRSTOFYR# = DATE(1,1,YEAROFDAY#)
    WEEKOF#    = (DATEIN - FIRSTOFYR# + (FIRSTOFYR# % 7 + 1) |
                 / 7 + 1)
    RETURN(WEEKOF#)
